Index: branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsCommonApproval.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsCommonApproval.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsCommonApproval.cs	(revision 366)
@@ -0,0 +1,1410 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Diagnostics;
+using System.Data;
+using System.Drawing;
+using System.Text;
+using System.Windows.Forms;
+using System.Collections;
+using System.Linq;
+using System.Threading.Tasks;
+
+using log4net;
+using log4net.Appender;
+using log4net.Repository.Hierarchy;
+
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.DataModel;
+using ProcessManagement.Forms.ControlsAction;
+using ProcessManagement.Forms.CustomControls;
+
+namespace ProcessManagement.Common
+{
+    /// <summary>
+    /// 申請・承認共通クラス
+    /// </summary>
+    public static class ClsCommonApproval
+    {
+        #region 使用定義
+        //log4netログを使用する
+        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
+        #endregion
+
+        #region 定数
+
+        #region 申請レコード番号
+        /// <summary>
+        /// 申請レコード枝番
+        /// </summary>
+        private const int s_PrimartyRecord = 1;
+        #endregion
+
+        #region 承認マスタ・データ一括取得読込順（工事承認）
+        /// <summary>
+        /// 承認マスタ・データ一括取得読込順（工事承認）
+        /// </summary>
+        private enum AppRoteNo
+        { 
+            /// <summary>
+            ///  0:マスタ承認番号
+            /// </summary>
+            ApprovalCode = 0,
+            /// <summary>
+            ///  1:マスタ部署コード
+            /// </summary>
+            DepartmentCode,
+            /// <summary>
+            ///  2:マスタSEQNO
+            /// </summary>
+            SeqNo,
+            /// <summary>
+            ///  3:マスタ承認順序
+            /// </summary>
+            DisplayOrder,
+            /// <summary>
+            ///  4:マスタ承認者コード
+            /// </summary>
+            ApprovalPerson,
+            /// <summary>
+            ///  5:マスタ最終承認者フラグ
+            /// </summary>
+            ApprovalAuthority,
+            /// <summary>
+            ///  6:データ工事コード
+            /// </summary>
+            ConstructionCode,
+            /// <summary>
+            ///  7:データ承認回数
+            /// </summary>
+            OrderNo,
+            /// <summary>
+            ///  8:データ承認者コード
+            /// </summary>
+            PersonCode,
+            /// <summary>
+            ///  9:データ承認者状態
+            /// </summary>
+            ApprovalStatus,
+        }
+        #endregion
+
+        #region 承認マスタ・データ一括取得処理SQL（工事承認）
+        /// <summary>
+        /// 承認マスタ・データ一括取得処理SQL（工事承認）
+        /// </summary>
+        private static string[] s_SQLAppRote = new string[] { "Select",
+                                                                    " A.ApprovalCode",
+                                                                    ", A.DepartmentCode",
+                                                                    ", A.SeqNo",
+                                                                    ", A.DisplayOrder",
+                                                                    ", A.ApprovalPerson",
+                                                                    ", A.ApprovalAuthority",
+                                                                    ", B.ConstructionCode",
+                                                                    ", B.OrderNo",
+                                                                    ", B.PersonCode",
+                                                                    ", B.ApprovalStatus",
+                                                                    " From",
+
+                                                                    " processapproval As P",
+
+                                                                    " Inner Join(Select",
+                                                                    "                 H.PersonCode",
+                                                                    "               , H.StartDate",
+                                                                    string.Format(" , Case When DATE (H.CompDate) = DATE('{0}')",DateTime.MinValue.ToShortDateString()),
+                                                                    string.Format("        Then DATE ('{0}')", DateTime.MaxValue.ToShortDateString()),
+                                                                    "                 Else DATE(H.CompDate) End As CompDate",
+                                                                    "               , H.DepartmentCode",
+                                                                    "               , H.DepartmentName",
+                                                                    "            From ChgChargeDep As H) As ChgMan",
+                                                                    "        On ChgMan.PersonCode = P.PersonCode",
+                                                                    "        And(DATE(ChgMan.StartDate) <= DATE(P.PetitionApprovalDate)",
+                                                                    "        And DATE(P.PetitionApprovalDate) <= DATE(ChgMan.CompDate))",
+
+                                                                    " Inner Join approvalmaster As A",
+                                                                    "        On A.ApprovalCode = P.ApprovalCode",
+                                                                    "        And A.DepartmentCode = ChgMan.DepartmentCode",
+
+                                                                    " Left  Join processapproval As B",
+                                                                    "        On B.ConstructionCode = P.ConstructionCode",
+                                                                    "        And B.ApprovalCode = P.ApprovalCode",
+                                                                    "        And B.OrderNo = P.OrderNo",
+                                                                    "        And B.PersonCode = A.ApprovalPerson",
+                                                                    "        And B.SeqNo > 1",
+
+                                                                    " Where P.ConstructionCode = {0}",                                      // 34
+                                                                    "   And P.ApprovalCode = {0}",                                          // 35
+                                                                    "   And P.OrderNo = {0}",                                               // 36
+                                                                    "   And P.SeqNo = {0}",                                                 // 37
+                                                                    " Order by A.DisplayOrder desc" };
+        #endregion
+
+        #endregion
+
+        #region 承認申請・承認をする(工事承認)
+        /// <summary>
+        /// 案件の承認申請・承認をする(工事承認)
+        /// </summary>
+        /// <returns>成功：true　失敗：false</returns>
+        public static bool CreatePetitionApproval(ProcessApproval Rec)
+        {
+            IOProcessApproval ApprDB = new IOProcessApproval();
+            try
+            {
+                string strSQL = ApprDB.CreatePrimarykeyString(Rec.ConstructionCode, Rec.ApprovalCode, Rec.OrderNo, Rec.SeqNo);
+                List<ProcessApproval> DataList = new List<ProcessApproval>();
+                // データがあるかをチェックする
+                if (!ApprDB.SelectAction(strSQL, ref DataList)) return false;
+
+                // データ追加時
+                if (DataList.Count == 0)
+                {
+                    if (!ApprDB.InsertAction(Rec)) return false;
+                    return true;
+                }
+
+                // データ更新時
+                if (!ApprDB.UpdateAction(strSQL, Rec)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ApprDB.close(); ApprDB = null;
+            }
+        }
+        #endregion
+
+        #region 承認申請・承認をする(担当者承認)
+        /// <summary>
+        /// 案件の承認申請・承認をする(担当者承認)
+        /// </summary>
+        /// <returns>成功：true　失敗：false</returns>
+        public static bool CreatePetitionApproval(PersonApproval Rec)
+        {
+            IOPersonApproval ApprDB = new IOPersonApproval();
+            try
+            {
+                string strSQL = ApprDB.CreatePrimarykeyString(Rec.PersonCode, Rec.ApprovalCode, Rec.OrderDate, Rec.OrderNo, Rec.SeqNo);
+                List<PersonApproval> DataList = new List<PersonApproval>();
+                // データがあるかをチェックする
+                if (!ApprDB.SelectAction(strSQL, ref DataList)) return false;
+
+                if (DataList.Count == 0)
+                {   // データ追加時
+                    if (!ApprDB.InsertAction(Rec)) return false;
+                }
+                else
+                {   // データ更新時
+                    if (!ApprDB.UpdateAction(strSQL, Rec)) return false;
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ApprDB.close(); ApprDB = null;
+            }
+        }
+        #endregion
+
+        #region 申請レコード更新(工事承認)
+        /// <summary>
+        /// 申請レコードを更新する(工事承認)
+        /// </summary>
+        /// <param name="ConstructionCode"></param>
+        /// <param name="ApprovalCode"></param>
+        /// <param name="Status"></param>
+        /// <returns></returns>
+        public static bool SetPrimaryRecStatus(int ConstructionCode, int ApprovalCode, int OrderNO, int Status)
+        {
+            IOProcessApproval ApprDB = new IOProcessApproval();
+            try
+            {
+                if (!ApprDB.UpdateFeild(ConstructionCode,
+                                        (int)IOProcessApproval.ColumnName.ApprovalStatus,
+                                        Status,
+                                        true,
+                                        ApprovalCode,
+                                        OrderNO,
+                                        s_PrimartyRecord)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ApprDB.close(); ApprDB = null;
+            }
+        }
+        #endregion
+
+        #region 申請レコード更新(担当者承認)
+        /// <summary>
+        /// 申請レコードを更新する(担当者承認)
+        /// </summary>
+        /// <param name="PersonCode"></param>
+        /// <param name="ApprovalCode"></param>
+        /// <param name="Status"></param>
+        /// <returns></returns>
+        public static bool SetPrimaryRecStatus(int PersonCode, int ApprovalCode, DateTime OrderDate, int OrderNo, int Status)
+        {
+            IOPersonApproval ApprDB = new IOPersonApproval();
+            try
+            {
+                if (!ApprDB.UpdateFeild(PersonCode,
+                                        ApprovalCode,
+                                        OrderDate,
+                                        (int)IOPersonApproval.ColumnName.ApprovalStatus,
+                                        Status,
+                                        true,
+                                        OrderNo,
+                                        s_PrimartyRecord)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ApprDB.close(); ApprDB = null;
+            }
+        }
+        #endregion
+
+        #region 申請確認（工事承認）
+        /// <summary>
+        /// 案件に対して申請がされているかを確認する
+        /// </summary>
+        /// <param name="ConstructionCode"></param>
+        /// <param name="ApprovalCode"></param>
+        /// <returns></returns>
+        public static bool CheckProcessPetition(int ConstructionCode, int ApprovalCode, int OrderNo)
+        {
+            IOProcessApproval ApprDB = new IOProcessApproval();
+            try
+            {
+                bool bPetition = false;
+                // 申請データ取得
+                string strSQL = ApprDB.CreatePrimarykeyString(ConstructionCode, ApprovalCode, OrderNo, s_PrimartyRecord);
+                List<ProcessApproval> PetitionList = new List<ProcessApproval>();
+                if (!ApprDB.SelectAction(strSQL, ref PetitionList)) return bPetition;
+                // 申請データが無い場合
+                if (PetitionList.Count != 0) bPetition = true;
+
+                return bPetition;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ApprDB.close(); ApprDB = null;
+            }
+        }
+        #endregion
+
+        #region 申請確認（担当者承認）
+        /// <summary>
+        /// 担当者申請がされているかを確認する
+        /// </summary>
+        /// <param name="PersonCode"></param>
+        /// <param name="ApprovalCode"></param>
+        /// <returns></returns>
+        public static bool CheckPersonPetition(int PersonCode, int ApprovalCode, DateTime ApprovalDate, int OrderNo)
+        {
+            IOPersonApproval ApprDB = new IOPersonApproval();
+            try
+            {
+                bool bPetition = false;
+                // 申請データ取得
+                StringBuilder strSQL = new StringBuilder();
+                strSQL.Append(ApprDB.CreatePrimarykeyString(PersonCode, ApprovalCode, ApprovalDate, OrderNo));
+                List<PersonApproval> PetitionList = new List<PersonApproval>();
+                if (!ApprDB.SelectAction(strSQL.ToString(), ref PetitionList)) return bPetition;
+                // 申請データが無い場合
+                if (PetitionList.Count != 0) bPetition = true;
+
+                return bPetition;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ApprDB.close(); ApprDB = null;
+            }
+        }
+        public static bool CheckPersonPetition2(int PersonCode, int ApprovalCode, DateTime ApprovalDate, int OrderNo)
+        {
+            IOPersonApproval ApprDB = new IOPersonApproval();
+            try
+            {
+                bool bPetition = false;
+                // 申請データ取得
+                StringBuilder strSQL = new StringBuilder();
+                strSQL.AppendFormat(" Where PersonCode = {0}", PersonCode);
+                strSQL.AppendFormat(" And ApprovalCode = {0}", ApprovalCode);
+                strSQL.AppendFormat(" And DATE(EntryDate) = DATE(STR_TO_DATE('{0}','%Y/%m/%d'))", ApprovalDate.ToShortDateString());
+                strSQL.AppendFormat(" And OrderNo = {0}", OrderNo);
+                List<PersonApproval> PetitionList = new List<PersonApproval>();
+                if (!ApprDB.SelectAction(strSQL.ToString(), ref PetitionList)) return bPetition;
+                // 申請データが無い場合
+                if (PetitionList.Count != 0) bPetition = true;
+
+                return bPetition;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ApprDB.close(); ApprDB = null;
+            }
+        }
+        #endregion
+
+        #region 最終承認確認（工事承認）
+        /// <summary>
+        /// 最終承認確認（工事承認）
+        /// </summary>
+        /// <param name="ConstructionCode"></param>
+        /// <param name="ApprovalCode"></param>
+        /// <returns></returns>
+        public static bool CheckProcessApproval(int ConstructionCode, int ApprovalCode, int Approvalcount)
+        {
+            IOMApproval mApprDB = new IOMApproval();
+            IOProcessApproval ApprDB = new IOProcessApproval();
+            try
+            {
+                // 承認データを取得する（申請データを除く）
+                string strData = ApprDB.CreatePrimarykeyString(ConstructionCode, ApprovalCode, Approvalcount, s_PrimartyRecord);
+                ProcessApproval DataRec = new ProcessApproval();
+                if (!ApprDB.SelectAction(strData, ref DataRec)) return false;
+
+                if (DataRec.ApprovalStatus != (int)CommonDefine.ApprovalStatus.Approval) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ApprDB.close(); ApprDB = null;
+                mApprDB.close(); mApprDB = null;
+            }
+        }
+        #endregion
+
+        #region 最終承認確認（担当者承認）
+        /// <summary>
+        /// 担当者申請に対して承認がされているかを確認する
+        /// </summary>
+        /// <param name="PersonCode"></param>
+        /// <param name="ApprovalCode"></param>
+        /// <returns></returns>
+        public static bool CheckPersonApproval(int PersonCode, int ApprovalCode, DateTime OrderDate, int OrderNo)
+        {
+            IOPersonApproval ApprDB = new IOPersonApproval();
+            try
+            {
+                // 承認データを取得する（申請データを除く）
+                string strData = ApprDB.CreatePrimarykeyString(PersonCode, ApprovalCode, OrderDate, OrderNo, s_PrimartyRecord);
+                PersonApproval DataRec = new PersonApproval();
+                if (!ApprDB.SelectAction(strData, ref DataRec)) return false;
+
+                if (DataRec.ApprovalStatus != (int)CommonDefine.ApprovalStatus.Approval) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ApprDB.close(); ApprDB = null;
+            }
+        }
+        #endregion
+
+        #region 承認確認（工事承認）
+        /// <summary>
+        /// 工事案件に対して最終承認がされているかを確認する
+        /// </summary>
+        /// <param name="ConstructionCode"></param>
+        /// <param name="ApprovalCode"></param>
+        /// <returns></returns>
+        public static bool CheckProcessApprovalData(int ConstructionCode, int ApprovalCode, int OrderNo)
+        {
+            IOConstructionBaseInfo cbiDB = new IOConstructionBaseInfo();
+            IOMApproval mApprDB = new IOMApproval();
+            IOProcessApproval ApprDB = new IOProcessApproval();
+            try
+            {
+                bool bApproval = false;
+                // 申請部署の取得
+                string strSQL = cbiDB.CreatePrimarykeyString(ConstructionCode);
+                ConstructionBaseInfo cbiData = new ConstructionBaseInfo();
+                if (!cbiDB.SelectAction(strSQL, ref cbiData)) return false;
+                int DepartmentCode = GetFromConstrAndAppTheDep(ConstructionCode, ApprovalCode, OrderNo);
+
+                // 承認経路マスタを取得する
+                string strMaster = mApprDB.CreatePrimarykeyString(ApprovalCode, DepartmentCode);
+                List<ApprovalMaster> MasterList = new List<ApprovalMaster>();
+                if (!mApprDB.SelectAction(strMaster, ref MasterList))
+                {
+                    logger.ErrorFormat("承認確認処理：{0}：承認経路マスタ取得エラー", CommonMotions.GetMethodName());
+                    return false;
+                }
+                if (MasterList.Count == 0) return false;
+
+                // 承認データを取得する
+                string strData = ApprDB.CreatePrimarykeyString(ConstructionCode, ApprovalCode, OrderNo);
+                //strData += string.Format(" And SeqNo != {0} And ApprovalStatus = {1}", s_PrimartyRecord, (int)CommonDefine.ApprovalStatus.Approval);
+                strData += " Order By SeqNo ASC";
+                List<ProcessApproval> DataList = new List<ProcessApproval>();
+                if (!ApprDB.SelectAction(strData, ref DataList)) return false;
+                if (DataList.Count == 0) return false;
+
+                // 申請データを取得する
+                ProcessApproval RequestData = DataList.Find(x => x.SeqNo == s_PrimartyRecord);
+                if (RequestData == null) return false;
+
+                int NoCnt = MasterList.Count;
+                foreach (ProcessApproval DataRec in DataList)
+                {
+                    // 申請データは対象にしない
+                    if (DataRec.SeqNo == s_PrimartyRecord) continue;
+
+                    // 承認以外は対象にしない
+                    if (DataRec.ApprovalStatus != (int)CommonDefine.ApprovalStatus.Approval) continue;
+
+                    foreach (ApprovalMaster MasterRec in MasterList)
+                    {
+                        // 承認者コードが違えば次レコードへ
+                        if (DataRec.PersonCode != MasterRec.ApprovalPerson) continue;
+
+                        // 承認していればデータ件数からマイナス
+                        --NoCnt;
+
+                        // 最終承認権限が設定されていれば承認済み
+                        if (MasterRec.ApprovalAuthority == (int)ApprovalMaster.ApprovalAuthorityDef.LastApproval)
+                        {
+                            // 最終承認済みは処理しない
+                            if (RequestData.ApprovalStatus == (int)CommonDefine.ApprovalStatus.Approval) break;
+
+                            bApproval = true;
+                            break;
+                        }
+                    }
+                    // 最終決裁者が承認していれば処理終了
+                    if (bApproval) break;
+                }
+                // マスタに設定されている承認者全員が承認していれば承認
+                if (NoCnt == 0)
+                {
+                    // 最終承認済みは処理しない
+                    if (RequestData.ApprovalStatus != (int)CommonDefine.ApprovalStatus.Approval)
+                    {
+                        bApproval = true;
+                    }
+                }
+
+                return bApproval;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ApprDB.close(); ApprDB = null;
+                mApprDB.close(); mApprDB = null;
+                cbiDB.close(); cbiDB = null;
+            }
+        }
+        #endregion
+
+        #region 承認確認（担当者承認）
+        /// <summary>
+        /// 担当者申請に対して最終承認がされているかを確認する
+        /// </summary>
+        /// <param name="PersonCode"></param>
+        /// <param name="ApprovalCode"></param>
+        /// <returns></returns>
+        public static bool CheckPersonApprovalData(int PersonCode, int ApprovalCode, DateTime OrderDate, int OrderNo)
+        {
+            IOConstructionBaseInfo cbiDB = new IOConstructionBaseInfo();
+            IOMApproval mApprDB = new IOMApproval();
+            IOPersonApproval ApprDB = new IOPersonApproval();
+            try
+            {
+                bool bApproval = false;
+
+                // 承認データを取得する（申請データを除く）
+                StringBuilder strSQL = new StringBuilder();
+                strSQL.Append("SELECT");
+                strSQL.Append(" A.DISPLAYORDER");
+                strSQL.Append(", A.APPROVALPERSON");
+                strSQL.Append(", A.APPROVALAUTHORITY");
+                strSQL.Append(", B.SEQNO");
+                strSQL.Append(", B.APPROVALSTATUS");
+                strSQL.Append(" FROM APPROVALMASTER A");
+                strSQL.Append(" LEFT JOIN PERSONAPPROVAL B");
+                strSQL.Append(" ON B.PERSONCODEAPPROVAL = A.APPROVALPERSON");
+                strSQL.Append(" AND B.APPROVALCODE = A.APPROVALCODE");
+                strSQL.AppendFormat(" AND DATE(B.ORDERDATE) = STR_TO_DATE('{0}','%Y/%m/%d')", OrderDate.ToShortDateString());
+                strSQL.AppendFormat(" AND B.ORDERNO = {0} AND B.SEQNO != {1}", OrderNo, s_PrimartyRecord);
+                strSQL.AppendFormat(" WHERE A.APPROVALCODE = {0}", ApprovalCode);
+                strSQL.Append(" AND A.DEPARTMENTCODE = ");
+                strSQL.Append(" (SELECT C.DEPARTMENTCODE");
+                strSQL.Append(" FROM PERSONINCHARGEMASTER C");
+                strSQL.AppendFormat(" WHERE C.PERSONCODE = {0})", PersonCode);
+                strSQL.Append(" ORDER BY A.DISPLAYORDER");
+
+                ArrayList DataList = new ArrayList();
+                if (!ApprDB.ExecuteReader(strSQL.ToString(), ref DataList)) return false;
+                if (DataList.Count == 0) return false;
+
+                int NoCnt = DataList.Count;
+                foreach (object[] DataRec in DataList)
+                {
+                    // 承認以外は対象にしない
+                    int StatData = CommonMotions.cnvInt(DataRec[4]);
+                    if (StatData != (int)CommonDefine.ApprovalStatus.Approval) continue;
+
+                    // 最終承認権限が設定されていれば承認済み
+                    int ApprovalAuthority = CommonMotions.cnvInt(DataRec[2]);
+                    if (ApprovalAuthority == 1)
+                    {
+                        bApproval = true;
+                        break;
+                    }
+
+                    // 承認していればデータ件数からマイナス
+                    --NoCnt;
+                }
+                // マスタに設定されている承認者全員が承認していれば承認
+                if (NoCnt == 0) bApproval = true;
+
+                return bApproval;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ApprDB.close(); ApprDB = null;
+                mApprDB.close(); mApprDB = null;
+                cbiDB.close(); cbiDB = null;
+            }
+        }
+        #endregion
+
+        #region 承認順序確認（工事承認）
+        /// <summary>
+        /// 承認順序確認（工事承認）
+        /// </summary>
+        /// <returns></returns>
+        public static bool CheckProcessApprovalSequence(int ConstrCode, int ApprovalCode, int OrderNo)
+        {
+            IOProcessApproval ApprDB = new IOProcessApproval();
+            try
+            {
+                // 申請・承認中はデータを取得する
+                StringBuilder strSQL = new StringBuilder();
+                int nLoppCnt = s_SQLAppRote.Length - 1;
+                for(int i = 0; i < nLoppCnt; i++)
+                {
+                    switch (i)
+                    {
+                        case 34:
+                            strSQL.AppendFormat(s_SQLAppRote[i], ConstrCode);
+                            break;
+                        case 35:
+                            strSQL.AppendFormat(s_SQLAppRote[i], ApprovalCode);
+                            break;
+                        case 36:
+                            strSQL.AppendFormat(s_SQLAppRote[i], OrderNo);
+                            break;
+                        case 37:
+                            strSQL.AppendFormat(s_SQLAppRote[i], CommonDefine.s_Default_OrderNo);
+                            break;
+                    default:
+                            strSQL.Append(s_SQLAppRote[i]);
+                            break;
+                    }
+                }
+                strSQL.Append(" Order By A.DisplayOrder");
+                ArrayList arList = new ArrayList();
+                if (!ApprDB.ExecuteReader(strSQL.ToString(), ref arList)) return false;
+
+                // 申請データが無い場合は新規なのでそのままでOK
+                if (arList.Count < 1) return true;
+
+                bool bCheck = true;
+                foreach (object[] CurRec in arList)
+                {
+                    // ログイン者が承認者にあれば抜ける
+                    if (CommonMotions.cnvInt(CurRec[(int)AppRoteNo.ApprovalPerson]) == CommonMotions.LoginUserData.PersonCode)
+                    {
+                        // 最終承認者は順序を気にしない
+                        if (CommonMotions.cnvInt(CurRec[(int)AppRoteNo.ApprovalAuthority]) == (int)ApprovalMaster.ApprovalAuthorityDef.LastApproval)
+                        {
+                            bCheck = true;
+                        }
+                        break;
+                    }
+
+                    // 承認されていなければフラグOFF
+                    if (CommonMotions.cnvInt(CurRec[(int)AppRoteNo.ApprovalStatus]) != (int)CommonDefine.ApprovalStatus.Approval) bCheck = false;
+                }
+
+                return bCheck;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ApprDB.close(); ApprDB = null;
+            }
+        }
+        #endregion
+
+        #region ログインユーザーの承認者確認
+        /// <summary>
+        /// ログインユーザーは承認者かどうかを確認する
+        /// </summary>
+        /// <param name="ConstructionCode"></param>
+        /// <param name="ApprovalCode"></param>
+        /// <returns></returns>
+        public static bool CheckUserForApprover(int ApprovalCode, int DepartmentCode)
+        {
+            IOMApproval mApprDB = new IOMApproval();
+            try
+            {
+                // システム管理者は全ての権限を持つ
+                if (CommonMotions.LoginUserData.SecurityManagement == CommonDefine.AdminSecurityManagement) return true;
+
+                bool bApproval = false;
+
+                // 承認経路マスタを取得する
+                string strMaster = mApprDB.CreatePrimarykeyString(ApprovalCode, DepartmentCode);
+                List<ApprovalMaster> MasterList = new List<ApprovalMaster>();
+                if (!mApprDB.SelectAction(strMaster, ref MasterList))
+                {
+                    logger.ErrorFormat("承認確認処理：{0}：承認経路マスタ取得エラー", CommonMotions.GetMethodName());
+                    return false;
+                }
+                if (MasterList.Count == 0) return false;
+
+                foreach (ApprovalMaster MasterRec in MasterList)
+                {
+                    // 承認者コードが違えば次レコードへ
+                    if (MasterRec.ApprovalPerson != CommonMotions.LoginUserData.PersonCode) continue;
+                    // 承認者の場合は処理終了
+                    bApproval = true;
+                    break;
+                }
+
+                return bApproval;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                mApprDB.close(); mApprDB = null;
+            }
+        }
+        #endregion
+
+        #region ログインユーザーの申請者確認
+        /// <summary>
+        /// ログインユーザーは申請者かどうかを確認する
+        /// </summary>
+        public static bool CheckUserForApplicant(int ConstructionCode, int ApprovalCode, int OrderNo)
+        {
+            IOProcessApproval ApprDB = new IOProcessApproval();
+            try
+            {
+                // 申請データを取得する
+                StringBuilder strData = new StringBuilder();
+                strData.Append(ApprDB.CreatePrimarykeyString(ConstructionCode
+                                                            , ApprovalCode
+                                                            , OrderNo
+                                                            , s_PrimartyRecord));
+                ProcessApproval DataRec = new ProcessApproval();
+                if (!ApprDB.SelectAction(strData.ToString(), ref DataRec)) return false;
+
+                // ログイン者を確認
+                if (CommonMotions.LoginUserData.PersonCode != DataRec.PersonCode) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ApprDB.close(); ApprDB = null;
+            }
+        }
+        #endregion
+
+        #region 工事コードより現在管理担当部署コードを取得
+        /// <summary>
+        /// 工事コードより現在管理担当部署コードを取得する
+        /// </summary>
+        /// <param name="PersonCode"></param>
+        /// <returns></returns>
+        public static int GetFromConstructionTheDepartment(int ConstructionCode)
+        {
+            IOConstructionBaseInfo cbiDB = new IOConstructionBaseInfo();
+            IOMPersonInCharge picDB = new IOMPersonInCharge();
+            try
+            {
+                // 工事基本情報取得
+                ConstructionBaseInfo baseRec = new ConstructionBaseInfo();
+                string strSQL = string.Format(" Where ConstructionCode = {0}", ConstructionCode);
+                if (!cbiDB.SelectAction(strSQL, ref baseRec)) return 0;
+
+                // 担当者取得
+                int CurrentPersonCode = 0;
+                int iCode1 = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("依頼受け中")).Key;
+                int iCode2 = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("見積提出")).Key;
+                int iCode3 = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("仮 受 注")).Key;
+                if (baseRec.ConstructionStatusFlg == iCode1 ||
+                    baseRec.ConstructionStatusFlg == iCode2 ||
+                    baseRec.ConstructionStatusFlg == iCode3)
+                {
+                    CurrentPersonCode = baseRec.SalesPersonCode;
+                }
+                else
+                {
+                    CurrentPersonCode = baseRec.ConstructionPersonCode;
+                }
+
+                // 工事部署取得
+                PersonInChargeMaster PersonRec = new PersonInChargeMaster();
+                string strPerson = picDB.CreatePrimarykeyString(CurrentPersonCode);
+                if (!picDB.SelectAction(strPerson, ref PersonRec)) return 0;
+
+                return PersonRec.DepartmentCode;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return 0;
+            }
+            finally
+            {
+                picDB.close(); picDB = null;
+                cbiDB.close(); cbiDB = null;
+            }
+
+        }
+        #endregion
+
+        #region 工事コードと承認機能コードより現在管理担当部署コードを取得
+        /// <summary>
+        /// 工事コードと承認機能コードより現在管理担当部署コードを取得する
+        /// </summary>
+        /// <returns></returns>
+        public static int GetFromConstrAndAppTheDep(int ConstructionCode, int ApprovalCode, int OrderNo)
+        {
+            IOProcessApproval ApprovalDB = new IOProcessApproval();
+            try
+            {
+                // 管理担当者コードを取得する
+                StringBuilder strSQL = new StringBuilder();
+                strSQL.Append(ApprovalDB.CreatePrimarykeyString(ConstructionCode, ApprovalCode, OrderNo, s_PrimartyRecord));
+                ProcessApproval ApprovalRec = new ProcessApproval();
+
+                int CurrentPersonCode = 0;
+                DateTime AppDate = DateTime.Now;
+                if (ApprovalDB.SelectAction(strSQL.ToString(), ref ApprovalRec))
+                {   // 申請データがある時はそのデータ
+                    CurrentPersonCode = ApprovalRec.PersonCode;
+                    AppDate = ApprovalRec.PetitionApprovalDate;
+                }
+                else
+                {
+                    // データが無い場合（申請時）はログインユーザー
+                    CurrentPersonCode = CommonMotions.LoginUserData.PersonCode;
+                }
+
+                // 担当者部署取得
+                StringBuilder strPerson = new StringBuilder();
+
+                strPerson.Append(" Select * From");
+                strPerson.Append(" (Select");
+                strPerson.Append(" PersonCode");
+                strPerson.Append(", StartDate");
+                strPerson.Append(", Case");
+                strPerson.AppendFormat(" When DATE(CompDate) = DATE('{0}')", DateTime.MinValue.ToShortDateString());
+                strPerson.AppendFormat(" Then DATE('{0}')", DateTime.MaxValue.ToShortDateString());
+                strPerson.Append(" Else DATE(CompDate)");
+                strPerson.Append(" End As CompDate");
+                strPerson.Append(", DepartmentCode");
+                strPerson.Append(", DepartmentName");
+                strPerson.Append(" From");
+                strPerson.Append(" ChgChargeDep) As ChgMan");
+                strPerson.Append(" Where");
+                strPerson.AppendFormat(" ChgMan.PersonCode = {0}", CurrentPersonCode);
+                strPerson.AppendFormat(" And(DATE(ChgMan.StartDate) <= DATE('{0}') And DATE('{0}') <= DATE(ChgMan.CompDate))", AppDate.ToShortDateString());
+
+                ArrayList PersonRec = new ArrayList();
+                if (!ApprovalDB.ExecuteReader(strPerson.ToString(), ref PersonRec)) return 0;
+                if(PersonRec.Count<1) return 0;
+
+                object[] objRec = (object[])PersonRec[0];
+                int nDepartmentCode = CommonMotions.cnvInt(objRec[3]);
+
+                return nDepartmentCode;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return 0;
+            }
+            finally
+            {
+                ApprovalDB.close(); ApprovalDB = null;
+            }
+        }
+        #endregion
+
+        #region 担当者コードと承認機能コードより現在管理担当部署コードを取得
+        /// <summary>
+        /// 担当者コードと承認機能コードより現在管理担当部署コードを取得する
+        /// </summary>
+        /// <returns></returns>
+        public static int GetFromPersonAndApprovalTheDepartment(int PersonCode, int ApprovalCode, DateTime OrderDate, int OrderNo)
+        {
+            IOMPersonInCharge picDB = new IOMPersonInCharge();
+            IOPersonApproval ApprovalDB = new IOPersonApproval();
+            try
+            {
+                // 管理担当者コードを取得する
+                string strSQL = ApprovalDB.CreatePrimarykeyString(PersonCode, ApprovalCode, OrderDate, OrderNo, s_PrimartyRecord);
+                PersonApproval ApprovalRec = new PersonApproval();
+                int CurrentPersonCode = 0;
+                if (ApprovalDB.SelectAction(strSQL, ref ApprovalRec))
+                {   // 申請データがある時はそのデータ
+                    CurrentPersonCode = ApprovalRec.PersonCode;
+                }
+                else
+                {
+                    // データが無い場合（申請時）は申請ユーザー
+                    CurrentPersonCode = PersonCode;
+                }
+
+                // 担当者部署取得
+                PersonInChargeMaster PersonRec = new PersonInChargeMaster();
+                string strPerson = picDB.CreatePrimarykeyString(CurrentPersonCode);
+                if (!picDB.SelectAction(strPerson, ref PersonRec)) return 0;
+
+                return PersonRec.DepartmentCode;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return 0;
+            }
+            finally
+            {
+                ApprovalDB.close(); ApprovalDB = null;
+                picDB.close(); picDB = null;
+            }
+        }
+        #endregion
+
+        #region 工事コードと承認機能コードより現在管理担当者コードを取得
+        /// <summary>
+        /// 工事コードと承認機能コードより現在管理担当者コードを取得する
+        /// </summary>
+        /// <returns></returns>
+        public static int GetFromConstructionAndApprovalThePerson(int ConstructionCode, int ApprovalCode)
+        {
+            IOConstructionBaseInfo cbiDB = new IOConstructionBaseInfo();
+            try
+            {
+                // 工事基本情報取得
+                ConstructionBaseInfo baseRec = new ConstructionBaseInfo();
+                string strSQL = string.Format(" Where ConstructionCode = {0}", ConstructionCode);
+                if (!cbiDB.SelectAction(strSQL, ref baseRec)) return 0;
+
+                // 承認機能コードにより取得する担当者コードを取得する
+                string AppString = ClsExcute.AppovalList[ApprovalCode];
+                int CurrentPersonCode = 0;
+                if (AppString.Equals("積算見積書承認"))
+                {
+                    CurrentPersonCode = baseRec.SalesPersonCode;
+                }
+                else if (AppString.Equals("積算予算書承認"))
+                {
+                    CurrentPersonCode = baseRec.SalesPersonCode;
+                }
+                else if (AppString.Equals("工事予算書承認"))
+                {
+                    CurrentPersonCode = baseRec.ConstructionPersonCode;
+                }
+                else if (AppString.Equals("注文書承認"))
+                {
+                    CurrentPersonCode = baseRec.ConstructionPersonCode;
+                }
+                else if (AppString.Equals("継続案件承認"))
+                {
+                    CurrentPersonCode = baseRec.ConstructionPersonCode;
+                }
+                else if (AppString.Equals("請求承認"))
+                {
+                    CurrentPersonCode = baseRec.ConstructionPersonCode;
+                }
+                else if (AppString.Equals("工事日報承認"))
+                {
+                    CurrentPersonCode = baseRec.ConstructionPersonCode;
+                }
+                else if (AppString.Equals("議事録承認"))
+                {
+                    CurrentPersonCode = baseRec.ConstructionPersonCode;
+                }
+                else if (AppString.Equals("質疑承認"))
+                {
+                    CurrentPersonCode = baseRec.ConstructionPersonCode;
+                }
+
+                return CurrentPersonCode;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return 0;
+            }
+            finally
+            {
+                cbiDB.close(); cbiDB = null;
+            }
+        }
+        #endregion
+
+        #region 承認数取得（工事承認）
+        /// <summary>
+        /// 該当工事より承認数取得する
+        /// </summary>
+        /// <returns></returns>
+        public static int GetProcessApprovalDataCount(int ConstructionCode, int ApprovalCode, int ApprovalCount)
+        {
+            IOProcessApproval paDB = new IOProcessApproval();
+            try
+            {
+                // 承認データ取得
+                string strSQL = paDB.CreatePrimarykeyString(ConstructionCode, ApprovalCode, ApprovalCount);
+                strSQL += string.Format(" And SeqNo != {0} And ApprovalStatus = {1}", s_PrimartyRecord, (int)CommonDefine.ApprovalStatus.Approval);
+                List<ProcessApproval> ApprovalList = new List<ProcessApproval>();
+                if (!paDB.SelectAction(strSQL, ref ApprovalList)) return 0;
+
+                return ApprovalList.Count;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return 0;
+            }
+            finally
+            {
+                paDB.close(); paDB = null;
+            }
+        }
+        #endregion
+
+        #region 承認数取得（担当者承認）
+        /// <summary>
+        /// 担当者申請より承認数取得する
+        /// </summary>
+        /// <returns></returns>
+        public static int GetPersonApprovalDataCount(int PersonCode, int ApprovalCode, DateTime ApprovalDate)
+        {
+            IOPersonApproval paDB = new IOPersonApproval();
+            try
+            {
+                // 承認データ取得
+                string strSQL = paDB.CreatePrimarykeyString(PersonCode, ApprovalCode, ApprovalDate);
+                strSQL += string.Format(" And SeqNo != {0} And ApprovalStatus = {1}", s_PrimartyRecord, (int)CommonDefine.ApprovalStatus.Approval);
+                List<PersonApproval> ApprovalList = new List<PersonApproval>();
+                if (!paDB.SelectAction(strSQL, ref ApprovalList)) return 0;
+
+                return ApprovalList.Count;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return 0;
+            }
+            finally
+            {
+                paDB.close(); paDB = null;
+            }
+        }
+        #endregion
+
+        #region 承認経路数を取得する
+        /// <summary>
+        /// 承認マスタより承認経路数を取得する
+        /// </summary>
+        /// <param name="ApprovalCode"></param>
+        /// <param name="DepartmentCode"></param>
+        /// <returns></returns>
+        public static int GetApprovalMasterCount(int ApprovalCode, int DepartmentCode)
+        {
+            IOMApproval mpaDB = new IOMApproval();
+            try
+            {
+                // 承認経路マスタ取得
+                string strMSQL = mpaDB.CreatePrimarykeyString(ApprovalCode, DepartmentCode);
+                List<ApprovalMaster> MasterList = new List<ApprovalMaster>();
+                if (!mpaDB.SelectAction(strMSQL, ref MasterList)) return 0;
+
+                // 初期値セット
+                return MasterList.Count;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return 0;
+            }
+            finally
+            {
+                mpaDB.close(); mpaDB = null;
+            }
+        }
+        #endregion
+
+        #region 承認画面の起動を確認する
+        /// <summary>
+        /// 承認画面が起動しているかを確認する
+        /// </summary>
+        /// <returns></returns>
+        public static bool ExceApprovalScreen()
+        {
+            try
+            {
+                int ApprovalNo = (int)ClsExcute.SubFormExecuteNo.ApprovalScreen;
+                // 現在画面階層取得
+                int nPoint = ClsExcute.GetNowProcessPoint();
+                // 先頭はエラー
+                if (nPoint < 1) return false;
+
+                bool bRet = false;
+                // 承認画面からの画面遷移は1画面（対象画面）のみになったのですぐ前にあるはず
+                int nPrevCnt = ClsExcute.GetNowProcessPoint() - 1;
+                if (ClsExcute.ProcControlPara[nPrevCnt].ProcNo == ApprovalNo) { bRet = true; }
+
+                return bRet;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region << ---------- プロセス画面承認パネル制御
+        #region 制御パネル位置
+        /// <summary>
+        /// 制御パネル位置
+        /// </summary>
+        public enum AppPnlDef
+        {
+            /// <summary>
+            /// 未申請・承認済
+            /// </summary>
+            Normal = 0,
+            /// <summary>
+            /// 承認パネル
+            /// </summary>
+            Approval,
+        }
+        #endregion
+
+        #region 入力画面申請ボタン制御処理（工事承認）
+        /// <summary>
+        /// 入力画面申請ボタン制御処理（工事承認）
+        /// </summary>
+        /// <param name="ApprovalNo">承認処理番号</param>
+        /// <param name="ConstrCode">工事番号</param>
+        /// <param name="OrderNo">受付番号</param>
+        /// <param name="AppPnls">パネルリスト</param>
+        public static void CtrlConstrAppPanel(int ApprovalNo, int ConstrCode, int OrderNo, List<Panel> AppPnls)
+        {
+            try
+            {
+                // 対象パネルを全て非表示にする
+                foreach (Panel CurPnl in AppPnls) { CurPnl.Visible = false; }
+
+                // 案件に対して申請がされて無い場合
+                if (!CheckProcessPetition(ConstrCode, ApprovalNo, OrderNo))
+                {
+                    // 申請パネルを表示する（未申請）
+                    PetitionPanelDisplay(AppPnls, true, true);
+                }
+                else
+                {
+                    // 最終承認確認（工事承認）
+                    if (CheckProcessApproval(ConstrCode, ApprovalNo, OrderNo))
+                    {
+                        // 申請パネルを表示する（承認済）
+                        PetitionPanelDisplay(AppPnls, false, false);
+                        // 承認件数のセット
+                        SetApprovalCount(ApprovalNo, ConstrCode, OrderNo, AppPnls);
+                    }
+                    else
+                    {
+                        // 申請中でログイン者が承認者の場合は承認ボタンを表示する
+                        if(CheckUserForApprover(ApprovalNo, CommonMotions.LoginUserData.DepartmentCode))
+                        {
+                            // 承認パネル表示
+                            AppPnls[(int)AppPnlDef.Approval].Visible = true;
+                        }
+                        // ログインユーザーは申請者かどうかを確認する
+                        else if(CheckUserForApplicant(ConstrCode, ApprovalNo, OrderNo))
+                        {
+                            // 申請パネルを表示する（承認中）
+                            PetitionPanelDisplay(AppPnls, false, true);
+                            // 承認件数のセット
+                            SetApprovalCount(ApprovalNo, ConstrCode, OrderNo, AppPnls);
+                        }
+                    }
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 申請パネル状態表示
+        /// <summary>
+        /// 申請パネル状態表示
+        /// </summary>
+        private static void PetitionPanelDisplay(List<Panel> AppPnls, bool bPetition, bool bNone)
+        {
+            try
+            {
+                // 申請パネル表示
+                AppPnls[(int)AppPnlDef.Normal].Visible = true;
+                // 承認ボタンパネル非表示
+                AppPnls[(int)AppPnlDef.Approval].Visible = false;
+
+                // ボタン取得
+                Panel BasePnl = AppPnls[(int)AppPnlDef.Normal];
+                Button btnPetition = CommonMotions.GetButtton2Collection(BasePnl.Controls, "btnPetition");
+                Button btnApproval = CommonMotions.GetButtton2Collection(BasePnl.Controls, "btnApproval");
+                Label lblAppCnt = CommonMotions.GetLabel2Collection(BasePnl.Controls, "lblApprovalCount");
+                // 取得できない場合は処理しない
+                if (btnPetition == null || btnApproval == null || lblAppCnt == null) return;
+
+                if (bPetition)
+                {
+                    // 未申請ボタン
+                    PetitionButtonDisplay(btnPetition, btnApproval, lblAppCnt, bNone);
+                }
+                else
+                {
+                    // 承認済ボタン
+                    ApprovalButtonDisplay(btnPetition, btnApproval, lblAppCnt, bNone);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 申請パネル：申請ボタン表示
+        /// <summary>
+        /// 申請パネル：申請ボタン表示
+        /// </summary>
+        private static void PetitionButtonDisplay(Button btnPetition, Button btnApproval, Label lblAppCnt, bool bNone)
+        {
+            try
+            {
+                // 申請ボタン
+                btnPetition.Visible = true;
+                btnApproval.Visible = false;
+                lblAppCnt.Visible = false;
+
+                int nWidth = btnPetition.Width + btnApproval.Width + lblAppCnt.Width;
+                btnPetition.Size = new Size(nWidth, btnPetition.Size.Height);
+
+                btnPetition.BackColor = Color.White;
+                if (bNone)
+                {
+                    btnPetition.Text = CommonDefine.PetitionButtonString[0];
+                    btnPetition.ForeColor = Color.Red;
+                }
+                else
+                {
+                    btnPetition.Text = CommonDefine.PetitionButtonString[1];
+                    btnPetition.ForeColor = Color.Black;
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 申請パネル：承認済ボタン表示
+        /// <summary>
+        /// 申請パネル：承認済ボタン表示
+        /// </summary>
+        private static void ApprovalButtonDisplay(Button btnPetition, Button btnApproval, Label lblAppCnt, bool bNone)
+        {
+            try
+            {
+                // 承認済ボタン
+                btnPetition.Visible = false;
+                btnApproval.Visible = true;
+                lblAppCnt.Visible = true;
+
+                btnApproval.Location = btnPetition.Location;
+
+                int nWidth = btnPetition.Width + btnApproval.Width;
+                btnApproval.Size = new Size(nWidth, btnApproval.Size.Height);
+
+                btnApproval.BackColor = Color.White;
+                btnApproval.ForeColor = Color.Black;
+                if (bNone)
+                {
+                    btnApproval.Text = CommonDefine.ApprovalButtonString[0];
+                }
+                else
+                {
+                    btnApproval.Text = CommonDefine.ApprovalButtonString[1];
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 承認数表示
+        /// <summary>
+        /// 承認件数のセット
+        /// </summary>
+        private static void SetApprovalCount(int ApprovalNo, int ConstrCode, int OrderNo, List<Panel> AppPnls)
+        {
+            IOProcessApproval ApprDB = new IOProcessApproval();
+
+            // 承認データ取得
+            int AppCnt = 0;
+            // 承認経路マスタ取得
+            int MsCnt = 0;
+
+            Panel BasePnl = AppPnls[(int)AppPnlDef.Normal];
+            Label lblAppCnt = CommonMotions.GetLabel2Collection(BasePnl.Controls, "lblApprovalCount");
+            // 取得できない場合は処理しない
+            if (lblAppCnt == null) return;
+            try
+            {
+                StringBuilder strSQL = new StringBuilder();
+                int nLoppCnt = s_SQLAppRote.Length - 1;
+                for (int i = 0; i < nLoppCnt; i++)
+                {
+                    switch (i)
+                    {
+                        case 34:
+                            strSQL.AppendFormat(s_SQLAppRote[i], ConstrCode);
+                            break;
+                        case 35:
+                            strSQL.AppendFormat(s_SQLAppRote[i], ApprovalNo);
+                            break;
+                        case 36:
+                            strSQL.AppendFormat(s_SQLAppRote[i], OrderNo);
+                            break;
+                        case 37:
+                            strSQL.AppendFormat(s_SQLAppRote[i], CommonDefine.s_Default_OrderNo);
+                            break;
+                        default:
+                            strSQL.Append(s_SQLAppRote[i]);
+                            break;
+                    }
+                }
+
+                ArrayList arList = new ArrayList();
+                if (!ApprDB.ExecuteReader(strSQL.ToString(), ref arList)) return;
+                if (arList.Count < 1) return;
+
+                foreach (object[] CurRec in arList)
+                {
+                    // マスタ承認者数取得
+                    if (CommonMotions.cnvInt(CurRec[(int)AppRoteNo.ApprovalPerson]) > 0) MsCnt++;
+
+                    // データ承認者数取得
+                    if (CommonMotions.cnvInt(CurRec[(int)AppRoteNo.ApprovalStatus]) > 0) AppCnt++;
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                ApprDB.close(); ApprDB = null;
+
+                // 承認数セット
+                lblAppCnt.Text = string.Format("{0}/{1}", AppCnt, MsCnt);
+            }
+        }
+        #endregion
+        #endregion << ---------- プロセス画面承認パネル制御
+    }
+}
